#include <stdlib.h>
#include <iostream.h>

class element {
  public:
    int vsebina;
    element *naslednji;
};

class list {          /*RAZRED PREDNIK (PRAVA FUNK. JE LE IZPIS)*/
  protected:
    element *vrh;
  public:
    list () {vrh=NULL;}
    virtual void operator + (int vseb) {}
    virtual void operator -- () {}
    void izpis ();
};

void list::izpis ()          /*IZPIS SEZNAMA (NI BILO ZAHTEVANO)*/
{
  element *pom;
  pom=vrh;
  while (pom!=NULL) {
    cout<<pom->vsebina;
    if (pom->naslednji!=NULL) cout<<", ";
    pom=pom->naslednji;
  }
  cout<<endl;
}

class queue:public list {          /*VRSTA - ODVZEM NA ZACETKU, DODAJANJE NA KONCU*/
  public:
    void operator + (int vseb);
    void operator -- ();
};

void queue::operator + (int vseb)
{
  element *pom;
  if (vrh==NULL) {          /*CE JE SEZNAM PRAZEN*/
    vrh=new element;
    vrh->vsebina=vseb;
    vrh->naslednji=NULL;
  } else {          /*SICER GRE DO KONCA IN DODA TAM*/
    pom=vrh;
    while (pom->naslednji!=NULL) pom=pom->naslednji;
    pom->naslednji=new element;
    pom->naslednji->vsebina=vseb;
    pom->naslednji->naslednji=NULL;
  }
}

void queue::operator -- ()
{
  element *pom;
  if (vrh==NULL) cout<<"Vrsta je prazna."<<endl; else {
    cout<<"Izlocam "<<vrh->vsebina<<"."<<endl;
    pom=vrh;          /*VRH PREVEZE ZA 1 ELEMENT NAPREJ IN GA BRISE*/
    vrh=vrh->naslednji;
    delete pom;
  }
}

class stack:public list {          /*SKLAD - ODVZEM, DODAJANJE NA KONCU*/
  public:
    void operator + (int vseb);
    void operator -- ();
};

void stack::operator + (int vseb)          /*KOT PRI VRSTI*/
{
  element *pom;
  if (vrh==NULL) {
    vrh=new element;
    vrh->vsebina=vseb;
    vrh->naslednji=NULL;
  } else {
    pom=vrh;
    while (pom->naslednji!=NULL) pom=pom->naslednji;
    pom->naslednji=new element;
    pom->naslednji->vsebina=vseb;
    pom->naslednji->naslednji=NULL;
  }
}

void stack::operator -- ()
{
  element *pom;
  if (vrh==NULL) cout<<"Sklad je prazen."<<endl; else {
    if (vrh->naslednji==NULL) {          /*CE JE VRH EDINI, GA ZBRISE*/
      cout<<"Izlocam "<<vrh->vsebina<<"."<<endl;
      delete vrh;
      vrh=NULL;
    } else {          /*SICER GRE DO KONCA IN ZADNJEGA ZBRISE*/
      pom=vrh;
      while (pom->naslednji->naslednji!=NULL) pom=pom->naslednji;
      cout<<"Izlocam "<<pom->naslednji->vsebina<<"."<<endl;
      delete pom->naslednji;
      pom->naslednji=NULL;
    }
  }
}

class slist:public list {          /*UREJEN SEZNAM - ODVZEM NA ZACETKU, DODAJANJE PO VELIKOSTI (NARASCAJOCE)*/
  public:
    void operator + (int vseb);
    void operator -- ();
};

void slist::operator + (int vseb)
{
  element *nov=new element, *pom;
  nov->vsebina=vseb;
  if ((vrh==NULL) || (vseb<vrh->vsebina)) {          /*CE JE SEZNAM PRAZEN ALI CE JE TREBA DODATI NA ZACETKU, SE NAREDI NOV VRH, STARI PA SE VEZE NANJ*/
    nov->naslednji=vrh;
    vrh=nov;
  } else {          /*SICER SE POISCE 1. ELEMENT, OD KATEREGA NOVI NI VECJI IN SE NOVI ZVEZE PREDENJ*/
    pom=vrh;
    while ((pom->naslednji!=NULL ) && (vseb>=pom->naslednji->vsebina)) pom=pom->naslednji;
    nov->naslednji=pom->naslednji;
    pom->naslednji=nov;
  }
}

void slist::operator -- ()          /*KOT PRI VRSTI*/
{
  element *pom;
  if (vrh==NULL) cout<<"Seznam je prazen."<<endl; else {
    cout<<"Izlocam "<<vrh->vsebina<<"."<<endl;
    pom=vrh;
    vrh=vrh->naslednji;
    delete pom;
  }
}

void main ()
{
  list *seznam;
  queue vrsta;
  stack sklad;
  slist urseznam;
  int izbira;
  double st;
  cout<<"1 - vrsta, 2 - sklad, 3 - urejen seznam"<<endl;          /*IZBIRA TIPA SEZNAMA*/
  cin>>izbira;
  switch (izbira) {
    case 1: seznam=&vrsta; break;
    case 2: seznam=&sklad; break;
    case 3: seznam=&urseznam; break;
  }
  cout<<"Vpisuj cela stevila, ki naj se dodajo seznamu (0.1 - izpis, 0.2 - odvzem, 0.3 - konec):"<<endl;  /*OPERACIJE NAD SEZNAMOM*/
  do {
    cin>>st;
    if (st==0.1) seznam->izpis (); else
      if (st==0.2) --*seznam; else
	if (st!=0.2) *seznam+(int) st;
  } while (st!=0.3);
}
